The <Record> verb records the caller's voice and returns to you the URL of a file containing the audio recording. You can optionally generate text transcriptions of recorded calls by setting the 'transcribe' attribute of the <Record> verb to 'true'.
The <Record> verb supports the following attributes that modify its behavior:
| Attribute Name | Allowed Values | Default Value |
|---|---|---|
| action | relative or absolute URL | current document URL |
| method | GET, POST |
POST |
| timeout | positive integer | 5 |
| finishOnKey | any digit, #, * |
1234567890*# |
| maxLength | integer greater than 1 | 3600 (1 hour) |
| transcribe | true, false |
false |
| transcribeCallback | relative or absolute URL | none |
| playBeep | true, false |
true |
Use one or more of these attributes in a <Record> verb like so:
<?xml version="1.0" encoding="UTF-8"?>
<Response>
<Record timeout="10" transcribe="true" />
</Response>
The 'action' attribute takes an absolute or relative URL as a value. When recording is
finished Twilio will make a GET or POST request to this URL including the parameters
below. If no 'action' is provided, <Record> will default to requesting the current
document's URL.
After making this request, Twilio will continue the current call using the
TwiML received in your response. Keep in mind that by default Twilio will
re-request the current document's URL, which can lead to unwanted looping
behavior if you're not careful. Any TwiML verbs occuring after a <Record> are
unreachable.
There is one exception: if Twilio receives an empty recording, it will not make a request to the 'action' URL. The current call flow will continue with the next verb in the current TwiML document.
Twilio will pass the following parameters in addition to the standard TwiML Voice request parameters with its request to the 'action' URL:
| Parameter | Description |
|---|---|
| RecordingUrl | the URL of the recorded audio |
| RecordingDuration | the duration of the recorded audio (in seconds) |
| Digits | the key (if any) pressed to end the recording or 'hangup' if the caller hung up |
A request to the RecordingUrl will return a recording in binary WAV audio
format by default. To request the recording in MP3 format, append ".mp3" to the
RecordingUrl.
The 'method' attribute takes the value 'GET' or 'POST'. This tells Twilio whether to request the 'action' URL via HTTP GET or POST. This attribute is modeled after the HTML form 'method' attribute. 'POST' is the default value.
The 'timeout' attribute tells Twilio to end the recording after a number of seconds of silence has passed. The default is 5 seconds.
The 'finishOnKey' attribute lets you choose a set of digits that end the recording when entered. For example, if you set 'finishOnKey' to '#' and the caller presses '#', Twilio will immediately stop recording and submit 'RecordingUrl', 'RecordingDuration', and the '#' as parameters in a request to the 'action' URL. The allowed values are the digits 0-9, '#' and '*'. The default is '1234567890*#' (i.e. any key will end the recording). Unlike <Gather>, you may specify more than one character as a 'finishOnKey' value.
The 'maxLength' attribute lets you set the maximum length for the recording in seconds. If you set 'maxLength' to '30', the recording will automatically end after 30 seconds of recorded time has elapsed. This defaults to 3600 seconds (one hour) for a normal recording and 120 seconds (two minutes) for a transcribed recording.
The 'transcribe' attribute tells Twilio that you would like a text representation of the audio of the recording. Twilio will pass this recording to our speech-to-text engine and attempt to convert the audio to human readable text. The 'transcribe' option is off by default. If you do not wish to perform transcription, simply do not include the transcribe attribute.
<Record> verb, your account will be charged. See the pricing page for our transcription prices.
The 'transcribeCallback' attribute is used in conjunction with the 'transcribe' attribute. It allows you to specify a URL to which Twilio will make an asynchronous POST request when the transcription is complete. This is not a request for TwiML and the response will not change call flow, but the request will contain the standard TwiML request parameters as well as 'TranscriptionSid', 'TranscriptionStatus', 'TranscriptionText', 'TranscriptionUrl', 'RecordingSid' and 'RecordingUrl'.
If 'transcribeCallback' is specified, then there is no need to specify 'transcribe=true'. It is implied. If you specify 'transcribe=true' without a 'transcribeCallback', the completed transcription will be stored for you to retrieve later (see the REST API Transcriptions section), but Twilio will not asynchronously notify your application.
Twilio will pass the following parameters in addition to the standard TwiML Voice request parameters with its request to the 'transcribeCallback' URL:
| Parameter | Description |
|---|---|
| TranscriptionSid | The unique 34 character ID of the transcription. |
| TranscriptionText | Contains the text of the transcription. |
| TranscriptionStatus | The status of the transcription attempt: either 'completed' or 'failed'. |
| TranscriptionUrl | The URL for the transcription's REST API resource. |
| RecordingSid | The unique 34 character ID of the recording from which the transcription was generated. |
| RecordingUrl | The URL for the transcription's source recording resource. |
The 'playBeep' attribute allows you to toggle between playing a sound before the start of a recording. If you set the value to 'false', no beep sound will be played.
You can't nest any verbs within <Record> and you can't nest <Record> within any other verbs.
Twilio will execute the <Record> verb causing the caller to hear a beep and the recording to start. If the caller is silent for more than 5 seconds, hits the '#' key, or the recording maxlength time is hit, Twilio will make an HTTP POST request to the default 'action' (the current document URL) with the parameters 'RecordingUrl' and 'RecordingDuration'.
<?xml version="1.0" encoding="UTF-8"?>
<!-- page located at http://example.com/simple_record.xml -->
<Response>
<Record/>
</Response>
This is example shows a simple voicemail prompt. The caller is asked to leave a message at the beep. The <Record> verb beeps and begins recording up to 20 seconds of audio.
<?xml version="1.0" encoding="UTF-8"?>
<!-- page located at http://example.com/voicemail_record.xml -->
<Response>
<Say>
Please leave a message at the beep.
Press the star key when finished.
</Say>
<Record
action="http://foo.edu/handleRecording.php"
method="GET"
maxLength="20"
finishOnKey="*"
/>
<Say>I did not receive a recording</Say>
</Response>
<Record> verb exits after 5 seconds of silence, falling through to the next verb in the document. In this case, it would fall through to the <Say> verb. <Say> verb is never reached.<Say> verb is never reached.Twilio will record the caller. When the recording is complete, Twilio will transcribe the recording and make an HTTP POST request to the 'transcribeCallback' URL with a parameter containing a transcription of the recording.
<?xml version="1.0" encoding="UTF-8"?>
<!-- page located at http://example.com/record_and_transcribe.xml -->
<Response>
<Record transcribe="true" transcribeCallback="/handle_transcribe.php"/>
</Response>